# -*- coding: utf-8 -*-
"""
Created on Thu Jan 29 17:12:07 2015

@author: crovetta
"""

import copy
import diagram



class state(tuple):
    
    """ Class of state """
    
    def __repr__(self):
        s=list(self)
        aff='State'+str(s)
        
        
        
        return(aff)
    
    def get_number(self,z=0):
        
        if self.one_class():
            return sum(self)
        
        Mz=0
        for xk in self:
            Mz+=xk[z]
        
        return Mz
        
    
    def is_conform(self,M):
        
        if self.one_class():
            return sum(self)==M
            
        for z in xrange(0,len(M)):
            if self.get_number(z) != M[z]:
                return False
        
        return True
        
        
    
    def one_class(self):
        
        """ Said if the state contains only one class """
        
        return isinstance(self[0], int)
    
    
    def empty(self,k):
        
        """ Saids if the queue k is empty """
        
        if self.one_class():
            return self[k]==0
        
        return sum(self[k])==0
        
        
    def get_largest(self,i):
        
        """ Gets the largest class """
        
        xi=self[i]
        z=xi.index(max(xi))
        
        return z
        
        
    def get_priority(self,i):
        
        """ Gets the first priority class non empty """
        
        xi=self[i]
        Z=len(xi)
        for z in xrange(0,Z):
            if xi[z]>0:
                return z
        
        return -1
    
    
    def t1(self,i,j):
        
        """ Transition i->j in one class model """
        
        x=list(self)
        x[i]=x[i]-1
        x[j]=x[j]+1
            
        return state(x)
        
    def tz(self,i,j,z):
        
        """ Transition i->j in Z>1 class model """
        
        x=list(self)
        xi=list(self[i])
        xj=list(self[j])
        
        xi[z]=xi[z]-1
        xj[z]=xj[z]+1
        x[i]=tuple(xi)
        x[j]=tuple(xj)
        
        return state(x)
        
    
    def t(self,i,J,dis='PRIORITY'):
        
        if self.empty(i):
            return self
            
        if self.one_class():
            return self.t1(i,J)
            
        # Determine z
        if dis=='LONGEST':
            z=self.get_largest(i)
        else:
            z=self.get_priority(i)
        
        
        return(self.tz(i,J[z],z))
        
        
        

#  Z=1 ---> One class model ----------

def plusOne(x):
    x[-1]=x[-1]+1
    return x

def addZero(x):
    x.append(0)
    return x

def construct_StateSpace(k,m,C):
    
    """ Constructs the state space with a recursive method """

    if k==0:
        if m>C[k]:
            return []
        
        xk=[m]
        return [xk]

    if m==0:
        x0=[0 for x in xrange(0,k+1)]
        return [x0]

    X=construct_StateSpace(k-1,m,C)
    S0=[addZero(x) for x in X if isinstance(x,list)]

    X=construct_StateSpace(k,m-1,C)
    S1=[plusOne(x) for x in X if isinstance(x,list) and x[-1]<C[k]]

    S=S1+S0

        
    return S

def convert_inSetOfState(L):
    S={state(x) for x in L}
    return S
    

def makeStateSpace_1(K,M,C):
    L=construct_StateSpace(K-1,M,C)
    S=convert_inSetOfState(L)
    return S
    

def makeStateSpace_Z(K,vM,vC):
    
    Z=len(vM)
    C=[sum(c) for c in vC]
    K=len(C)
    M=sum(vM)
    
    

    # Determines the customers number in each queue
    BigS=construct_StateSpace(K-1,M,C)
    itBS=(sk for sk in BigS)
    
    
    # Determines the possible configurations in each queue
    dic={}
    uvC=set(vC)
    for v in uvC:
        sv=sum(v)
        for m in xrange(0,sv+1):
            mv=(m,v)
            lmv=construct_StateSpace(Z-1,m,v)
            lmv=[tuple(x) for x in lmv]
            dic[mv]=lmv
    
    
    # Construct S
    S=[]
    for x in itBS:
   
        v=vC[0]
        m=x[0]
        mv=(m,v)
        
        Sx1=[[x0] for x0 in dic[mv]] #First queue 
        
        for k in xrange(1,K):
            
            # Find possible xk
            v=vC[k]
            m=x[k]
            mv=(m,v)
            Xk=dic[mv]
            
            # Append the xk
            Sx2=[]
            for xk in Xk:
                Sxk=copy.deepcopy(Sx1)
                [ss.append(xk) for ss in Sxk]
                Sx2.extend(Sxk)
            Sx1=Sx2
        
        Sx1=[state(s1) for s1 in Sx1]
        Sx1=[s1 for s1 in Sx1  if s1.is_conform(vM)]
        
        S.extend(Sx1)
        SS=set(S)
      
    
    return SS
    
    

# -----------------------------

class SetStates(object):
    
    """ Class of set of states """
    
    def __init__(self,Mod):
        
        self.Model=Mod # Model
        
        # Makes the state space
        if self.Model.Z==1:
            self.states=makeStateSpace_1(self.Model.K,self.Model.M,self.Model.C)
        else:
            D=diagram.Diagram(Mod)
            self.states=D.to_setOfState()
            #self.states=makeStateSpace_Z(self.Model.K,self.Model.M,self.Model.C)
        
        self.statespace=copy.deepcopy(self.states)
        
    
    
    def __len__(self):
        return len(self.states)
        
    def __str__(self):
        l=[str(s) for s in self.states]
        aff="\n ".join(l)
        aff='\nS={\n '+aff+'\n}|S|='+str(len(self))
        return aff
        
        
    def reset(self):
        
        """ Gets all states in the set """        
        
        self.states=copy.deepcopy(self.statespace)
        
    
    def t(self,i,J,dis='PRIORITY'):
        
        """ 
        Transition on the set of state 
        
            Disciplines:
            - PRIORITY (delfault)
            - LONGEST
                        
        """
        
        self.states={x.t(i,J,dis) for x in self.states}
        
        
        
    def get_one_state(self):
        
        """ Returns the first state in the set """
        
        L=list(self.states)
        
        return L[0]
        
        
    
    
        





