# -*- coding: utf-8 -*-
"""
Created on Tue May 19 12:10:31 2015

@author: crovetta
"""

import numpy as np
from model import Model, ClassRouting
from state import SetStates, state
from diagram import Diagram

def PS_state(Mod):
    
    """ Produces one random state according to the stationnary distribution by uses Perfect Sampling on states """
    
    S=SetStates(Mod)
    
    n=1
    U=[Mod.rand_iJ()]
    
    (i,J)=U[0]
    S.t(i,J)
    
    while len(S)>1:
        
        S.reset()
        
        UU=[Mod.rand_iJ() for nn in xrange(0,n)]
        U=UU+U
        n=n*2
        
        itU=(r for r in U)
        for (i,J) in itU:
            S.t(i,J)
    
    return S.get_one_state()
    
    
def PS_diagram(Mod):
    
    """ Produces one random state according to the stationnary distribution by uses Perfect Sampling on diagram"""
    
    D=Diagram(Mod)
    
    n=1
    U=[Mod.rand_iJ()]
    
    (i,J)=U[0]
    D.T(i,J)
    
    while D.onePath()==False:
        
        D.reset()
        
        UU=[Mod.rand_iJ() for nn in xrange(0,n)]
        U=UU+U
        n=n*2
        
        itU=(r for r in U)
        for (i,J) in itU:
            D.T(i,J)
            
    SD=D.psi()
    
    return state(SD[0])


# Modele 1
#M=5
#Mu=(1,1,1)
#P1=np.array([[0,0.5,0.5],[1,0,0],[1,0,0]])
#R1=ClassRouting(P1)
#
#Mod1=Model(M,Mu,[R1])
#print Mod1
#(i,j)=Mod1.rand_iJ()
#print 'i=',i
#print 'j=',j
#
#help(SetStates)
#S1=SetStates(Mod1)
#print S1
#S1.t(0,1)
#print S1
#S1.reset()
#
#help(Diagram)
#D1=Diagram(Mod1)
#print 'Nombre d arrete dans D1: ',len(D1)
#D1.plot()
#D1.T(0,1)
#D1.plot()
#print 'Nombre d arrete dans D1: ',len(D1)
#print 'Nombre d etats dans D1: ',D1.card_psi()
#print D1.to_setOfState()
#print 'D1 contient un seul etat: ',D1.onePath()
#D1.reset()
#print 'Nombre d etats dans D1: ',D1.card_psi()
#
#print PS_state(Mod1)
#print PS_diagram(Mod1)

# Modele 2
M=(2,3)
Mu=(1,1,1,1,1)
R1=ClassRouting(np.array([[0,0.5,0.5,0,0],[1,0,0,0,0],[1,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0]]))
R2=ClassRouting(np.array([[0,0,0,0,0],[0,0,0,0,1],[0,0,0,1,0],[0,0.8,0.2,0,0],[0,0,0.5,0.5,0]]))
Mod2=Model(M,Mu,[R1,R2])
print Mod2

S2=SetStates(Mod2)
S2.t(1,[0,4])
print 'Taille de S2: ',len(S2)
D2=Diagram(Mod2)
D2.T(1,[0,4])
print 'Taille de D2: |A|=',len(D2)
print 'Nombre d etats dans D2: ',D2.card_psi()
#D2.plot()

print PS_state(Mod2)
print PS_diagram(Mod2)